# $Revision: 1.79 $, $Date: 2010/08/27 08:35:26 $
#
# Conditional build:
%bcond_without	dist_kernel	# allow non-distribution kernel
%bcond_without	kernel		# don't build kernel modules
%bcond_without	userspace	# don't build userspace tools
%bcond_with	verbose		# verbose build (V=1)

%if %{without kernel}
%undefine	with_dist_kernel
%endif
%if "%{_alt_kernel}" != "%{nil}"
%undefine	with_userspace
%endif
%if %{without userspace}
# nothing to be placed to debuginfo package
%define		_enable_debug_packages	0
%endif

%define		rel	17
%define		pname	ipset
Summary:	IP sets utility
Summary(pl.UTF-8):	Narzędzie do zarządzania zbiorami IP
Name:		%{pname}%{_alt_kernel}
Version:	4.2
Release:	%{rel}
License:	GPL
Group:		Networking/Admin
Source0:	http://ipset.netfilter.org/%{pname}-%{version}.tar.bz2
# Source0-md5:	9060d549a18c1c0794fa47a71343d627
Source1:	%{pname}.init
Patch0:		shadow-args.patch
URL:		http://ipset.netfilter.org/
%{?with_dist_kernel:BuildRequires:	kernel%{_alt_kernel}-module-build >= 3:2.6.20.2}
%{?with_userspace:BuildRequires:	linux-libc-headers >= 7:2.6.22.1-2}
BuildRequires:	rpmbuild(macros) >= 1.379
Suggests:	kernel-net-ipset
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
IP sets are a framework inside the Linux 2.4.x and 2.6.x kernel, which
can be administered by the ipset utility. Depending on the type,
currently an IP set may store IP addresses, (TCP/UDP) port numbers or
IP addresses with MAC addresses in a way, which ensures lightning
speed when matching an entry against a set.

%description -l pl.UTF-8
Zbiory IP to szkielet w jądrze Linuksa 2.4.x i 2.6.x, którym można
administrować przy użyciu narzędzia ipset. W zależności od rodzaju
aktualnie zbiór IP może przechowywać adresy IP, numery portów
(TCP/UDP) lub adresy IP z adresami MAC - w sposób zapewniający
maksymalną szybkość przy dopasowywaniu elementu do zbioru.

%package devel
Summary:	Header files for ipset interface
Summary(pl.UTF-8):	Pliki nagłówkowe do interfejsu ipset
Group:		Development/Libraries

%description devel
Header files for IPset interface.

%description devel -l pl.UTF-8
Pliki nagłówkowe do interfejsu IPset.

%package init
Summary:	IPset init script
Summary(pl.UTF-8):	Skrypt startowy IPset
Group:		Networking/Admin
Requires(post,preun):	/sbin/chkconfig
Requires:	%{pname} = %{version}-%{release}
Requires:	rc-scripts

%description init
IPset initialization script.

%description init -l pl.UTF-8
Skrypt startowy IPset.

%package -n kernel%{_alt_kernel}-net-ipset
Summary:	IPset kernel modules
Summary(pl.UTF-8):	Moduły jądra oferujące wsparcie dla zbiorów IP
Release:	%{rel}@%{_kernel_ver_str}
Group:		Base/Kernel
%{?with_dist_kernel:%requires_releq_kernel}
Requires(post,postun):	/sbin/depmod

%description -n kernel%{_alt_kernel}-net-ipset
IP sets are a framework inside the Linux 2.4.x and 2.6.x kernel, which
can be administered by the ipset utility. Depending on the type,
currently an IP set may store IP addresses, (TCP/UDP) port numbers or
IP addresses with MAC addresses in a way, which ensures lightning
speed when matching an entry against a set.

This package contains kernel modules.

%description -n kernel%{_alt_kernel}-net-ipset -l pl.UTF-8
Zbiory IP to szkielet w jądrze Linuksa 2.4.x i 2.6.x, którym można
administrować przy użyciu narzędzia ipset. W zależności od rodzaju
aktualnie zbiór IP może przechowywać adresy IP, numery portów
(TCP/UDP) lub adresy IP z adresami MAC - w sposób zapewniający
maksymalną szybkość przy dopasowywaniu elementu do zbioru.

Ten pakiet zawiera moduły jądra oferujące wsparcie dla zbiorów IP.

%prep
%setup -q -n %{pname}-%{version}
%patch0 -p1
mv kernel/{Kbuild,Makefile}

# these options can be overriden by module parameters.
# maximum number of ipsets.
%{__sed} -i 's:$(IP_NF_SET_MAX):256:' kernel/Makefile
# hash size for bindings of IP sets.
%{__sed} -i 's:$(IP_NF_SET_HASHSIZE):1024:' kernel/Makefile

%if "%{cc_version}" < "3.4"
%{__sed} -i -e 's/-Wextra//' Makefile
%{__sed} -i -e 's/-Winit-self//' Makefile
%{__sed} -i -e 's/-Wold-style-definition//' Makefile
%{__sed} -i -e 's/-Wno-missing-field-initializers//' Makefile
%endif

%build
%if %{with userspace}
%{__make} binaries \
	CC="%{__cc}" \
	PREFIX="%{_prefix}" \
	LIBDIR="%{_libdir}" \
	MANDIR="%{_mandir}" \
	BINDIR="%{_sbindir}" \
	COPT_FLAGS:="%{rpmcflags}"
%endif

%if %{with kernel}
# ugly hack for satisfy rpm build macro. in fact all modules will be built.
%build_kernel_modules -C kernel -m ip_set
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with userspace}
install -d $RPM_BUILD_ROOT{/etc/rc.d/init.d,%{_includedir}}

%{__make} binaries_install \
	DESTDIR="$RPM_BUILD_ROOT" \
	PREFIX="%{_prefix}" \
	LIBDIR="%{_libdir}" \
	MANDIR="%{_mandir}" \
	BINDIR="%{_sbindir}"

cp -a *.h $RPM_BUILD_ROOT%{_includedir}
install -p %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{pname}
%endif

%if %{with kernel}
cd kernel
%install_kernel_modules -m ip_set -d kernel/net/ipv4/netfilter
install -p ip_set_*.ko $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter
install -p ipt_*.ko $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter
cd -
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post init
/sbin/chkconfig --add %{pname}

%preun init
if [ "$1" = "0" ]; then
	/sbin/chkconfig --del %{pname}
fi

%post	-n kernel%{_alt_kernel}-net-ipset
%depmod %{_kernel_ver}

%postun	-n kernel%{_alt_kernel}-net-ipset
%depmod %{_kernel_ver}

%if %{with userspace}
%files
%defattr(644,root,root,755)
%doc ChangeLog ChangeLog.ippool TODO
%attr(755,root,root) %{_sbindir}/ipset
%dir %{_libdir}/ipset
%attr(755,root,root) %{_libdir}/ipset/libipset_*.so
%{_mandir}/man8/ipset.8*

%files devel
%defattr(644,root,root,755)
%{_includedir}/ipset.h
%{_includedir}/libipt_set.h

%files init
%defattr(644,root,root,755)
%attr(754,root,root) /etc/rc.d/init.d/ipset
%endif

%if %{with kernel}
%files -n kernel%{_alt_kernel}-net-ipset
%defattr(644,root,root,755)
/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter/ip_set*.ko*
/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter/ipt_set*.ko*
/lib/modules/%{_kernel_ver}/kernel/net/ipv4/netfilter/ipt_SET*.ko*
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: ipset.spec,v $
Revision 1.79  2010/08/27 08:35:26  arekm
- release 17

Revision 1.78  2010/08/22 05:47:00  arekm
- release 16

Revision 1.77  2010/08/15 16:42:15  arekm
- release 15

Revision 1.76  2010/08/11 09:27:53  arekm
- release 14

Revision 1.75  2010/08/09 07:57:09  arekm
- release 13

Revision 1.74  2010/07/30 12:29:25  glen
- release 12

Revision 1.73  2010/07/21 11:14:33  glen
- drop BR perl-base, perl not used during build

Revision 1.72  2010/07/21 05:56:08  glen
- verbose files

Revision 1.71  2010/07/21 05:53:45  glen
- comment cosmetics

Revision 1.70  2010/07/21 05:27:41  glen
- update to build on ac

Revision 1.69  2010/07/19 13:57:17  paszczus
- added Suggests: kernel-net-ipset

Revision 1.68  2010/07/06 16:11:53  arekm
- release 11

Revision 1.67  2010/05/28 17:57:18  arekm
- release 10

Revision 1.66  2010/05/18 17:38:31  arekm
- release 9

Revision 1.65  2010/05/16 13:27:52  pluto
- release 8 (rebuild with kernel-2.6.33.4)

Revision 1.64  2010/04/28 13:29:33  arekm
- release 7

Revision 1.63  2010/04/13 16:43:50  pluto
- release 6 (rebuild with kernel-2.6.33.2-1)

Revision 1.62  2010/03/17 07:28:31  arekm
- release 5

Revision 1.61  2010/03/16 06:14:02  arekm
- release 4

Revision 1.60  2010/03/06 18:15:06  pluto
- oops, correct release to 3.

Revision 1.59  2010/03/06 18:12:12  pluto
- release 3 (rebuild with 2.6.32.9-4)

Revision 1.58  2010/02/15 09:40:31  arekm
- release 2

Revision 1.57  2010/01/27 21:30:43  kosmo
- updated to 4.2

Revision 1.56  2010/01/08 18:10:25  arekm
- release 9

Revision 1.55  2009/12/19 11:00:21  arekm
- release 8

Revision 1.54  2009/12/16 18:00:08  arekm
- release 7

Revision 1.53  2009/12/12 20:02:49  arekm
- release 6

Revision 1.52  2009/11/22 20:58:03  arekm
- release 5

Revision 1.51  2009/11/12 09:37:49  arekm
- release 4

Revision 1.50  2009/11/01 16:38:54  arekm
- release 3

Revision 1.49  2009/10/21 19:05:49  arekm
- release 2

Revision 1.48  2009/08/20 08:38:54  adamg
- updated to 3.1

Revision 1.47  2009/08/01 20:10:52  arekm
- release 2

Revision 1.46  2009/07/08 20:06:06  hawk
- allow to keep more than one build in single ftp tree

Revision 1.45  2009/05/20 08:41:49  amateja
- updated to 3.0

Revision 1.44  2009/04/21 20:01:57  arekm
- release 6

Revision 1.43  2009/03/25 19:40:20  arekm
- release 5

Revision 1.42  2009/03/23 14:02:32  gotar
- main package doesn't require depmod, don't duplicate license field

Revision 1.41  2009/03/18 08:40:43  arekm
- release 4

Revision 1.40  2009/03/13 19:58:16  arekm
- release 2

Revision 1.39  2009/03/07 17:39:30  areq
- 2.5.0

Revision 1.38  2009/02/26 21:46:34  arekm
- release 2

Revision 1.37  2009/02/25 13:48:28  areq
- 2.4.9

Revision 1.36  2009/02/17 23:04:01  arekm
- release 4

Revision 1.35  2009/02/14 13:47:55  pluto
- release 3.

Revision 1.34  2009/02/10 07:27:27  arekm
- release 2

Revision 1.33  2009/02/09 22:02:20  arekm
- up to 2.4.7 (2.6.28 compatibility)

Revision 1.32  2009/02/07 16:56:46  arekm
- release 6

Revision 1.31  2009/01/25 12:55:30  arekm
- release 5

Revision 1.30  2009/01/19 12:30:10  arekm
- release 4

Revision 1.29  2009/01/15 12:53:59  arekm
- release 3

Revision 1.28  2009/01/10 22:37:22  arekm
- release 2

Revision 1.27  2009/01/05 10:32:38  pluto
- updated to 2.4.5.

Revision 1.26  2008/12/19 06:30:49  arekm
- release 8

Revision 1.25  2008/12/14 11:42:42  arekm
- release 7

Revision 1.24  2008/12/06 08:59:56  arekm
- release 6

Revision 1.23  2008/12/04 00:58:49  pluto
- release 5 for 2.6.27.7-3.

Revision 1.22  2008/11/21 19:14:32  arekm
- release 4

Revision 1.21  2008/11/08 09:26:53  arekm
- release 3

Revision 1.20  2008/11/04 08:22:05  pluto
- release 2.

Revision 1.19  2008/10/28 19:17:05  qboosh
- pl for -init, strict dep

Revision 1.18  2008/10/27 13:15:21  glen
- complete alt_kernel support (src.rpm to include alt kernel brand)

Revision 1.17  2008/10/27 13:13:30  glen
- unify (from template-kernel-module.spec)

Revision 1.16  2008/10/27 10:00:16  pluto
- updated to 2.4.3, add kernel modules w/ 2.6.27 support.

Revision 1.15  2008/08/13 15:40:59  kosmo
- updated to 2.3.3a

Revision 1.14  2007/12/11 06:53:32  pluto
- adapterized, init script updated.

Revision 1.13  2007-12-10 20:13:05  pluto
- add init script.

Revision 1.12  2007-10-15 23:46:55  zbyniu
- up to 2.3.0-20070828

Revision 1.11  2007/04/04 09:03:41  gotar
- up to 2.2.9a

Revision 1.10  2007/02/13 08:06:35  glen
- tabs in preamble

Revision 1.9  2007/02/12 00:48:57  baggins
- converted to UTF-8

Revision 1.8  2006/06/09 15:35:26  wolf
- cosmetics

Revision 1.7  2006/01/26 19:48:53  dzeus
- up to 2.2.8

Revision 1.6  2005/12/13 20:10:43  qboosh
- fixed -devel descs

Revision 1.5  2005/12/11 13:04:59  djrzulf
- created devel subpackage, i think right :),

Revision 1.4  2005/11/24 11:01:15  pluto
- updated to 2.2.7, all modules enabled, release 1.

Revision 1.3  2005/11/14 21:17:30  qboosh
- pl

Revision 1.2  2005/11/09 12:40:42  jajcus
- patch for Makefile not to use kernel headers (from /usr/src)

Revision 1.1  2005/11/09 10:57:18  jajcus
- new spec
